/*
 * Original source: https://crypto.stanford.edu/~blynn/rop/
 *
 * Modern computers and compilers implement various techniques
 * to make attacks harder. For getting started, compile this
 * file with
 *
 *     gcc -fno-stack-protector -z execstack
 *
 * to disable stack protection and to have the stack memory pages
 * marked as executable. Note that gcc will likely complain about the
 * usage of gets() - but we use it only as a simple example for any
 * other code that may fail to do proper bounds checking.
 */

#include <stdio.h>

#define DEBUG

int main()
{
    char name[64];

#ifdef DEBUG
    fprintf(stderr, "character array name is at %p\n", name);
#endif

    puts("What's your name?");
    gets(name);
    printf("Hello, %s!\n", name);
    return 0;
}
